<template>
  	<!-- Sign In Popup -->
					<div id="sign-in-dialog" class="zoom-anim-dialog">

						<div class="small-dialog-header">
							<h3>Sign In</h3>
						</div>
							
						<!--Tabs -->
						<div class="sign-in-form style-1">
							<tabs class="sign-in-form style-1 tabs-nav">
								<tab name="Login">
									<br><br>
									<i v-if="invalidLogin" class="fa fa-warning" style="color:red;"></i>
        						<span v-if="invalidLogin" class="help is-danger" style="color:red;">Invalid Email or Password please check your credentials</span>
											<br>
									<!-- Login -->
									<form @submit="onSubmit" class="login">

										<p class="form-row form-row-wide">
											<label for="username">
											<i class="fa fa-at"></i>
												<input type="text" class="input-text" name="email" placeholder="Email" v-model.trim="user.email"
                                                 />
											</label>
										</p>

										<p class="form-row form-row-wide">
											<label for="password">
												<i class="fa fa-key"></i>
												<input class="input-text" type="password" placeholder="Password" name="password" v-model.trim="user.password" />
											</label>
											<!--<span class="lost_password">
										<a href="#" >Lost Your Password?</a>
									</span>-->
										</p>


										<div class="form-row">
											<input type="submit" class="button border margin-top-5" name="login" value="Login" />
											<!--<div class="checkboxes margin-top-10">
										<input id="remember-me" type="checkbox" name="check">
										<label for="remember-me">Remember Me</label>
									</div>-->
										</div>

									</form>
								</tab>
								<tab name="Register" class>	
							<!-- Register -->

										<form @submit.prevent="validateForm('form-2')" class="register" data-vv-scope="form-2">

										<!--	<p class="form-row form-row-wide">
												<label for="username">
													<i class="fa fa-user"></i>
													<input type="text" class="input-text" name="username" v-validate="'required'" :class="{'input': true, 'is-danger': errors.has('form-2.username') }" 
													placeholder="Username"  v-model.trim="user.username" />
												</label>
												 <i v-show="errors.has('form-2.username')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.username')" class="help is-danger" style="color:red;">{{ errors.first('form-2.username') }}</span>
											
											</p>-->
										<br>
											<p class="form-row form-row-wide">
												<label for="email">
													<i class="fa fa-at"></i>
													<input  type="text" class="input-text" name="email" v-validate="'required|email'" :class="{'input': true, 'is-danger': errors.has('form-2.email') }" 
													placeholder="Email" v-model.trim="user.email" />
												   	</label>
														  <i v-show="errors.has('form-2.email')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.email')" class="help is-danger" style="color:red;">{{ errors.first('form-2.email') }}</span>
											</p>

												<p class="form-row form-row-wide">
												<label for="firstname">Firstname:
													<i class="fa fa-at"></i>
													<input  type="text" class="input-text" name="firstname" v-validate="'required'" :class="{'input': true, 'is-danger': errors.has('form-2.firstname') }" 
													placeholder="Firstname" v-model.trim="user.firstname" />
												   	</label>
														  <i v-show="errors.has('form-2.firstname')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.firstname')" class="help is-danger" style="color:red;">{{ errors.first('form-2.firstname') }}</span>
											</p>

												<p class="form-row form-row-wide">
												<label for="lastname">Lastname:
													<i class="fa fa-at"></i>
													<input  type="text" class="input-text" name="lastname" v-validate="'required'" :class="{'input': true, 'is-danger': errors.has('form-2.lastname') }" 
													placeholder="Lastname" v-model.trim="user.lastname" />
												   	</label>
														  <i v-show="errors.has('form-2.lastname')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.lastname')" class="help is-danger" style="color:red;">{{ errors.first('form-2.lastname') }}</span>
											</p>
											
										<p class="form-row form-row-wide">
												<label for="age">Age:
													<i class="fa fa-sort-numeric-asc"></i>
													<input type="number" class="input-text" name="age"  
													placeholder="Age"  v-model.trim="user.age" />
												</label>
												
											</p>
											<p class="form-row form-row-wide">
												<label for="sex">Sex:
													<select name="sex" id="" v-model.trim="user.sex">	
														<option value="Male">Male</option>
															<option value="Female">Female</option>
													</select>
												</label>
											</p>
											<p class="form-row form-row-wide">
												<label for="password">Password:
												<i class="fa fa-key"></i>
													<input class="input-text" name="password" v-validate="'required|min:6'" :class="{'input': true, 'is-danger': errors.has('form-2.password') }" 
													type="password" placeholder="Password"  v-model.trim="user.password" />
												  	</label>
														 <i v-show="errors.has('form-2.password')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.password')" class="help is-danger"  style="color:red;">{{ errors.first('form-2.password') }}</span>
											
											</p>

											<p class="form-row form-row-wide">
												<label for="ConfirmPassword">Repeat Password:
													<i class="fa fa-key"></i>
													<input class="input-text" name="ConfirmPassword" v-validate="'required|confirmed:password'" :class="{'input': true, 'is-danger': errors.has('form-2.ConfirmPassword') }" 
													type="password" placeholder="Confirm Password"  />
												</label>
												 <i v-show="errors.has('form-2.ConfirmPassword')" class="fa fa-warning" style="color:red;"></i>
                						<span v-show="errors.has('form-2.ConfirmPassword')" class="help is-danger"  style="color:red;">{{ errors.first('form-2.ConfirmPassword') }}</span>
											
											</p>

											<input type="submit" class="button border fw margin-top-10" name="register" value="Register" />

										</form>
								</tab>
							</tabs>
							<!--<ul class="tabs-nav">
								<li class="">
									<a href="#tab1">Log In</a>
								</li>
								<li>
									<a href="#tab2">Register</a>
								</li>
							</ul>-->

							
						</div>
						
					</div>
					
					<!-- Sign In Popup / End -->
</template>

<script>
import LoginService from "@/services/LoginService";
import axios from "axios";
import VueLocalStorage from "vue-localstorage";
import Vue from "vue";
import Tabs from "vue-tabs-component";
import swal from "sweetalert2";
import { mapFields } from "vee-validate";

Vue.use(Tabs);

Vue.use(VueLocalStorage);

export default {
  name: "login",
  data() {
    return {
      user: {},
      msg: "Welcome to login",
      invalidLogin: false,
      //	email: '',
      username: "",
      emails: Array
    };
    const validator = {
      getMessage(field, args) {
        // will be added to default English messages.
        // Returns a message.
      },
      validate(value, args) {
        // Returns a Boolean or a Promise.
      }
    };
  },
  computed: mapFields(["name", "email", "scope.email"]),
  methods: {
    validateForm(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          // eslint-disable-next-line
          // swal("Good job!", "You have successfully registered!", "success");
          this.onSubmitToRegister();
        }
      });
    },
    onSubmit(evt) {
      var self = this;
      evt.preventDefault();
      //console.log(this.user);
      axios
        .post("http://34.244.196.28:443/users/login", this.user)
        .then(response => {
          console.log("user logged in");
          Vue.localStorage.set("user", JSON.stringify(response));
          self.$router.push("/home");
          self.$router.go("/home");
        })
        .catch(() => {
          self.invalidLogin = true;
        });
    },
    onSubmitToRegister() {
      //evt.preventDefault();
      self = this;
      console.log(this.user);
      axios
        .post("http://34.244.196.28:443/users/register", this.user)
        .then(response => {
          console.log("test" + response.data);
          if (response.data == "mail already exists") {
            swal({
              type: "error",
              title: "Oops...",
              text: "Email Already Exists!"
            });
          } else {
            swal({
              title: "",
              text: "You are now registered",
              type: "success",
              confirmButtonColor: "#3085d6",
              confirmButtonText: "Ok"
            }).then(result => {
              if (result.value) {
								console.log("user registred");        
                 self.$router.push(
              {
                name: "login"
              },
              function() {
                location.reload();
              }
            );
              }
            });
              
          }
        })
        .catch(e => {
          console.log(e);
        });
    },
    checkUserAvailable() {
      self = this;
      var users = [];
      axios
        .get("http://34.244.196.28:443/users")
        .then(response => {
          console.log("all users");
          users.push(response.data);
          users.forEach(element => {
            this.emails.push(element.email);
          });
        })
        .catch(e => {
          console.log(e);
        });
    }
  }
};
</script>
